/*
File: comb.c
Author: Martin Voros
*/
#include "comb.h"
#include "common.h"

int* 
init_array(unsigned int size)
{
	int *p;
	int i;
	p=(int *) xmalloc(sizeof(int) * size);
	for (i=0; i<size; i++) {
		p[i]=i;
	}
	return p;
}

int **
gen_comb(unsigned int degree, unsigned int var)
{
	int *c;
	unsigned int i,k,l;
	unsigned long j;
	int **all=NULL; 
	extern counter;
	
	for(i=1; i<=degree; i++) {
		c=init_array(i);
		j=cn(var,i);
		all=(int **)xrealloc((void *)all,sizeof(int *) * (j+counter));
		for (k=0; k<j; k++) {
			all[counter]=(int *)xmalloc(sizeof(int)*(i+1));
			for (l=0; l<i; l++) {
				all[counter][l]=c[l];
			}
			all[counter][l]=-1;
			comb(var,i,c);
			counter++;
		}
		/* free(c); */
	}
	return all;
}

void
comb(unsigned int n, unsigned int k, int * a)
{
	unsigned int i = k - 1;
	unsigned int j;
	
	while (a[i] == n - k + i) {
		i--;
	}

	a[i] = a[i] + 1;
	for (j=i + 1; j < k; j++) {
		a[j] = a[i] + j - i;
	}
}

unsigned long 
fact(unsigned int n)
{
	unsigned int i;
	unsigned long buf=1;
	
	if (n == 0) return 1;
	else {
		for (i=1;i<=n; i++) {
			buf=buf*i;	
		}
		return buf;
	}
}

unsigned long 
cn(unsigned int n, unsigned int k)
{
	unsigned int i;
	unsigned long buf=n;

	for (i=0; i<k-1; i++) {
		buf=buf*(n-i-1);
	}
	if (k == 0) return buf;
		else return (buf / fact(k));
}

void 
gen_eq(FILE * out, 
	unsigned long num, 
	int ** c,
	unsigned long n, 
	unsigned long f, 
	unsigned long p, 
	short logic, 
	short sol,
	unsigned long var)
{
	unsigned long j=0,k,m,r,s;
	unsigned long res1, res2;
	int * solution;
	int stat;
	
	srand(time(0));
	
	/* Get random solution*/
	if (sol) {
		solution = (int *)xmalloc(sizeof(int) * var);
		for (j=0; j<var; j++)
			solution[j] = random() % f;
		fprintf(out, "%% Solution: (");
		for (j=0; j<var; j++)
			fprintf(out, "x_%lu=%lu,", j, solution[j]);
		fprintf(out, ")\n"); 
	}

	j = 0;
	while (j<num) {
		stat=0;
		res1 = 0;
		for (k=0; k<n; k++) {
			r=random();
			if ( (r % p) == 0) {
				res2 = 1;
				m=0;
				if (stat) 
					fprintf(out, "+");
				s=r%f;
				if (s>1) {
					fprintf(out,"%lu*",s);
					res2 *= s;
				}
				while (c[k][m] != -1) {
					if (logic) {
						fprintf(out,"%i",c[k][m]+1);
					} else { 
						fprintf(out,"x%i",c[k][m]);
					}
					res2 *= solution[c[k][m]];
					if (c[k][m+1] != -1) {
						fprintf(out,"*");
					}	
					m++;
				}
				res1 += res2;
				stat=1;
			}
		}
		if (stat>0) {
			if (sol) res1 = res1 % f;
			else res1 = random() % f;

			if (logic) fprintf(out," = %lu.\n",res1);
			else fprintf(out,"=%lu\n",res1);

			j++;
		}
	}

	if (sol)
		free(solution);
}
