#include <stdio.h>
#include <sicstus/sicstus.h>

int
user_main(int argc, char **argv)
{
       int rval;
       SP_pred_ref pred;
       SP_qid goal;
       SP_term_ref input, output;

	/* Parse arguemtns */
	if (argc < 3) {
		fprintf(stderr,"Required arguments are missing. \n");
		fprintf(stderr,"Usage: poly2cnf [source] [dest] \n");
		return 1;
	}


	if (SP_FAILURE == SP_initialize(argc, argv, NULL)) {
		fprintf(stderr, "SP_initialize failed: %s\n", SP_error_message(SP_errno));
		return 1;
	}

	rval = SP_restore("poly2cnf.sav");
	if (rval == SP_ERROR || rval == SP_FAILURE) {
		fprintf(stderr, "Could not restore \"poly2cnf.sav\".\n");
		return 1;
	}

	if (!(pred = SP_predicate("lo",2,"user"))) {
		fprintf(stderr, "Could not find lo/2.\n");
		return 1;
	}

 	SP_put_string(input = SP_new_term_ref(), argv[1]);
	SP_put_string(output = SP_new_term_ref(), argv[2]);

	if (!(goal = SP_query_cut_fail(pred,input,output))) {
		fprintf(stderr, "Failed to open query.\n");
		return 1;
	}

	SP_close_query(goal);
	
	return 0;
}
